diff -urNb sbcl/contrib/sb-simple-streams/impl.lisp sbcl.char/contrib/sb-simple-streams/impl.lisp
--- sbcl/contrib/sb-simple-streams/impl.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/contrib/sb-simple-streams/impl.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -173,7 +173,7 @@
 	   (index 0)			; current index in current buffer
 	   (total 0))			; total characters
       (declare (type simple-stream encap)
-	       (type simple-base-string cbuf)
+	       (type simple-string cbuf)
 	       (type cons bufs tail)
 	       (type sb-int:index index total))
       (loop
@@ -200,7 +200,7 @@
 		(do ((list bufs (cdr list)))
 		    ((eq list tail))
 		  (let ((buf (car list)))
-		    (declare (type simple-base-string buf))
+		    (declare (type simple-string buf))
 		    (replace cbuf buf :start1 idx)
 		    (incf idx (length buf)))))
 	      (return (values (sb-kernel:shrink-vector cbuf total)
@@ -210,7 +210,7 @@
 		  (index 0))
 	      (declare (type sb-int:index index))
 	      (dolist (buf bufs)
-		(declare (type simple-base-string buf))
+		(declare (type simple-string buf))
 		(replace string buf :start1 index)
 		(incf index (length buf)))
 	      (return  (values string (eq done :eof)))))
diff -urNb sbcl/make-host-1.sh sbcl.char/make-host-1.sh
--- sbcl/make-host-1.sh	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/make-host-1.sh	2004-10-29 15:19:19.000000000 +0200
@@ -43,6 +43,9 @@
 	(when (find :sb-test *shebang-features*)
 	  (load "tests/type.before-xc.lisp")
 	  (load "tests/info.before-xc.lisp"))
+        (load "tools-for-build/ucd.lisp")
+        (sb-cold::slurp-ucd)
+        (sb-cold::output)
         (host-cload-stem "src/compiler/generic/genesis")
 	(sb!vm:genesis :c-header-dir-name "src/runtime/genesis")
         #+cmu (ext:quit)
diff -urNb sbcl/package-data-list.lisp-expr sbcl.char/package-data-list.lisp-expr
--- sbcl/package-data-list.lisp-expr	2004-10-29 14:57:26.000000000 +0200
+++ sbcl.char/package-data-list.lisp-expr	2004-10-29 15:19:19.000000000 +0200
@@ -63,6 +63,7 @@
 	     "SAP-ALIEN" "SHORT" "SIGNED" "SLOT" "STRUCT"
 	     "UNSIGNED"
 	     "UNSIGNED-CHAR" "UNSIGNED-INT" "UNSIGNED-LONG" "UNSIGNED-SHORT"
+             "UTF8-STRING"
 	     "VOID"
 	     "WITH-ALIEN"))
 
@@ -910,7 +911,7 @@
 
 	       ;; various internal defaults
 	       "DEFAULT-INIT-CHAR" "*DEFAULT-INIT-CHAR-FORM*"
-	       "*LOAD-SOURCE-DEFAULT-TYPE*"
+	       "*LOAD-SOURCE-DEFAULT-TYPE*" "BASE-CHAR-CODE-LIMIT"
 
 	       ;; hash caches
 	       "DEFINE-HASH-CACHE"
@@ -1122,13 +1123,14 @@
                "ARRAY-TYPE" "ARRAY-TYPE-COMPLEXP"
                "ARRAY-TYPE-DIMENSIONS" "ARRAY-TYPE-ELEMENT-TYPE"
                "ARRAY-TYPE-P" "ARRAY-TYPE-SPECIALIZED-ELEMENT-TYPE"
-               "ASH-INDEX" "ASSERT-ERROR" "BASE-STRING-P"
+               "ASH-INDEX" "ASSERT-ERROR" "BASE-CHAR-P" "BASE-STRING-P"
                "BINDING-STACK-POINTER-SAP" "BIT-BASH-COPY" "BIT-INDEX"
                "BOGUS-ARG-TO-VALUES-LIST-ERROR" "BOOLE-CODE"
                "BOUNDING-INDICES-BAD-ERROR" "BYTE-SPECIFIER" "%BYTE-BLT"
                "CALLABLE" "CASE-BODY-ERROR"
               "CHARACTER-SET" "CHARACTER-SET-TYPE"
               "CHARACTER-SET-TYPE-PAIRS"
+	       "CHARACTER-STRING-P"
               "CHARPOS"
                "CHECK-FOR-CIRCULARITY" "CHECK-TYPE-ERROR" "CLOSED-FLAME"
                "CODE-COMPONENT" "CODE-COMPONENT-P" "CODE-DEBUG-INFO"
@@ -1232,7 +1234,8 @@
                "NUMERIC-TYPE-HIGH" "NUMERIC-TYPE-LOW" "NUMERIC-TYPE-P"
                "OBJECT-NOT-ARRAY-ERROR" "OBJECT-NOT-CHARACTER-ERROR"
                "OBJECT-NOT-BASE-STRING-ERROR" "OBJECT-NOT-BIGNUM-ERROR"
-               "OBJECT-NOT-BIT-VECTOR-ERROR" "OBJECT-NOT-COMPLEX-ERROR"
+               "OBJECT-NOT-BIT-VECTOR-ERROR"
+	       "OBJECT-NOT-CHARACTER-STRING-ERROR" "OBJECT-NOT-COMPLEX-ERROR"
                "OBJECT-NOT-COMPLEX-FLOAT-ERROR"
                "OBJECT-NOT-COMPLEX-SINGLE-FLOAT-ERROR"
                #!+long-float "OBJECT-NOT-COMPLEX-LONG-FLOAT-ERROR"
@@ -1298,6 +1301,7 @@
                "OBJECT-NOT-SIMPLE-ARRAY-SIGNED-BYTE-8-ERROR"
                "OBJECT-NOT-SIMPLE-BIT-VECTOR-ERROR"
                "OBJECT-NOT-SIMPLE-BASE-STRING-ERROR"
+	       "OBJECT-NOT-SIMPLE-CHARACTER-STRING-ERROR"
                "OBJECT-NOT-SIMPLE-STRING-ERROR"
                "OBJECT-NOT-SIMPLE-VECTOR-ERROR"
                "OBJECT-NOT-SINGLE-FLOAT-ERROR" "OBJECT-NOT-STRING-ERROR"
@@ -1306,7 +1310,9 @@
                "OBJECT-NOT-UNSIGNED-BYTE-32-ERROR"
                ;; FIXME: 32/64-bit issues
                "OBJECT-NOT-UNSIGNED-BYTE-64-ERROR"
-               "OBJECT-NOT-VECTOR-ERROR" "OBJECT-NOT-WEAK-POINTER-ERROR"
+               "OBJECT-NOT-VECTOR-ERROR"
+	       "OBJECT-NOT-VECTOR-NIL-ERROR"
+	       "OBJECT-NOT-WEAK-POINTER-ERROR"
                "ODD-KEY-ARGS-ERROR" "OUTPUT-OBJECT" "OUTPUT-UGLY-OBJECT"
                "PACKAGE-DESIGNATOR" "PACKAGE-DOC-STRING"
                "PACKAGE-HASHTABLE-SIZE" "PACKAGE-HASHTABLE-FREE"
@@ -1353,6 +1359,7 @@
                "SIMPLE-ARRAY-SIGNED-BYTE-61-P"
                "SIMPLE-ARRAY-SIGNED-BYTE-64-P"
                "SIMPLE-ARRAY-SIGNED-BYTE-8-P" "SIMPLE-BASE-STRING-P"
+	       "SIMPLE-CHARACTER-STRING-P"
                "SIMPLE-PACKAGE-ERROR" "SIMPLE-UNBOXED-ARRAY"
                "SINGLE-FLOAT-BITS" "SINGLE-FLOAT-EXPONENT"
                "SINGLE-FLOAT-INT-EXPONENT" "SINGLE-FLOAT-SIGNIFICAND"
@@ -1997,7 +2004,8 @@
 	       "COMPLEX-SINGLE-FLOAT-IMAG-SLOT" "COMPLEX-SINGLE-FLOAT-REAL-SLOT"
 	       "COMPLEX-SINGLE-FLOAT-SIZE" "COMPLEX-SINGLE-FLOAT-WIDETAG"
 	       "COMPLEX-SINGLE-REG-SC-NUMBER" "COMPLEX-SINGLE-STACK-SC-NUMBER"
-	       "COMPLEX-SIZE" "COMPLEX-BASE-STRING-WIDETAG" "COMPLEX-WIDETAG"
+	       "COMPLEX-SIZE" "COMPLEX-BASE-STRING-WIDETAG"
+	       "COMPLEX-CHARACTER-STRING-WIDETAG" "COMPLEX-WIDETAG"
 	       "COMPLEX-VECTOR-NIL-WIDETAG"
 	       "COMPLEX-VECTOR-WIDETAG" "CONS-CAR-SLOT" "CONS-CDR-SLOT"
 	       "CONS-SIZE" "CONSTANT-SC-NUMBER"
@@ -2137,6 +2145,7 @@
 	       "SIMPLE-ARRAY-SIGNED-BYTE-8-WIDETAG"
 	       "SIMPLE-BIT-VECTOR-WIDETAG"
 	       "SIMPLE-BASE-STRING-WIDETAG"
+	       "SIMPLE-CHARACTER-STRING-WIDETAG"
 	       "SIMPLE-VECTOR-WIDETAG" "SINGLE-FLOAT-BIAS"
 	       "SINGLE-FLOAT-DIGITS" "SINGLE-FLOAT-EXPONENT-BYTE"
 	       "SINGLE-FLOAT-HIDDEN-BIT" "SINGLE-FLOAT-NORMAL-EXPONENT-MAX"
diff -urNb sbcl/src/code/array.lisp sbcl.char/src/code/array.lisp
--- sbcl/src/code/array.lisp	2004-10-28 22:28:17.000000000 +0200
+++ sbcl.char/src/code/array.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -91,8 +91,10 @@
     ;; and for all in any reasonable user programs.)
     ((t)
      (values #.sb!vm:simple-vector-widetag #.sb!vm:n-word-bits))
-    ((base-char standard-char character)
+    ((base-char standard-char)
      (values #.sb!vm:simple-base-string-widetag #.sb!vm:n-byte-bits))
+    ((character)
+     (values #.sb!vm:simple-character-string-widetag #.sb!vm:n-word-bits))
     ((bit)
      (values #.sb!vm:simple-bit-vector-widetag 1))
     ;; OK, we have to wade into SUBTYPEPing after all.
@@ -110,8 +112,10 @@
     ;; Pick off some easy common cases.
     ((t)
      #.sb!vm:complex-vector-widetag)
-    ((base-char character)
+    ((base-char)
      #.sb!vm:complex-base-string-widetag)
+    ((character)
+     #.sb!vm:complex-character-string-widetag)
     ((nil)
      #.sb!vm:complex-vector-nil-widetag)
     ((bit)
@@ -120,7 +124,8 @@
     (t
      (pick-vector-type type
        (nil #.sb!vm:complex-vector-nil-widetag)
-       (character #.sb!vm:complex-base-string-widetag)
+       (base-char #.sb!vm:complex-base-string-widetag)
+       (character #.sb!vm:complex-character-string-widetag)
        (bit #.sb!vm:complex-bit-vector-widetag)
        (t #.sb!vm:complex-vector-widetag)))))
 
@@ -148,7 +153,8 @@
 		 (array (allocate-vector
 			 type
 			 length
-			 (ceiling (* (if (= type sb!vm:simple-base-string-widetag)
+			 (ceiling (* (if (or (= type sb!vm:simple-base-string-widetag)
+					     (= type sb!vm:simple-character-string-widetag))
 					 (1+ length)
 					 length)
 				     n-bits)
@@ -854,7 +860,8 @@
 	  ,@(map 'list
 		 (lambda (saetp)
 		   `((simple-array ,(sb!vm:saetp-specifier saetp) (*))
-		     ,(if (eq (sb!vm:saetp-specifier saetp) 'character)
+		     ,(if (or (eq (sb!vm:saetp-specifier saetp) 'character)
+			      (eq (sb!vm:saetp-specifier saetp) 'base-char))
 			  *default-init-char-form*
 			  (sb!vm:saetp-initial-element-default saetp))))
 		 (remove-if-not
diff -urNb sbcl/src/code/char.lisp sbcl.char/src/code/char.lisp
--- sbcl/src/code/char.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/char.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -12,6 +12,8 @@
 
 (in-package "SB!IMPL")
 
-(def!constant sb!xc:char-code-limit 256
+(def!constant sb!xc:char-code-limit #x110000
   #!+sb-doc
   "the upper exclusive bound on values produced by CHAR-CODE")
+
+(def!constant base-char-code-limit 128)
diff -urNb sbcl/src/code/class.lisp sbcl.char/src/code/class.lisp
--- sbcl/src/code/class.lisp	2004-10-28 22:28:32.000000000 +0200
+++ sbcl.char/src/code/class.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -939,6 +939,11 @@
                 :codes (#.sb!vm:character-widetag)
                 :translation (character-set)
                 :prototype-form (code-char 42))
+     #+nil
+     (base-char :enumerable t
+		:inherits (character)
+		:codes (#.sb!vm:base-char-widetag)
+                :prototype-form (code-char 42))
      (symbol :codes (#.sb!vm:symbol-header-widetag)
              :prototype-form '#:mu)
 
@@ -1243,6 +1248,19 @@
       :inherits (base-string simple-string string vector simple-array
 		 array sequence)
       :prototype-form (make-array 0 :element-type 'base-char))
+     (character-string
+      :translation (vector character)
+      :codes (#.sb!vm:complex-character-string-widetag)
+      :direct-superclasses (string)
+      :inherits (string vector array sequence)
+      :prototype-form (make-array 0 :element-type 'character :fill-pointer t))
+     (simple-character-string
+      :translation (simple-array character (*))
+      :codes (#.sb!vm:simple-character-string-widetag)
+      :direct-superclasses (character-string simple-string)
+      :inherits (character-string simple-string string vector simple-array
+		 array sequence)
+      :prototype-form (make-array 0 :element-type 'character))
      (list
       :translation (or cons (member nil))
       :inherits (sequence))
diff -urNb sbcl/src/code/cold-init.lisp sbcl.char/src/code/cold-init.lisp
--- sbcl/src/code/cold-init.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/cold-init.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -111,6 +111,8 @@
   ;; this to be initialized, so we initialize it right away.
   (show-and-call !random-cold-init)
 
+  (show-and-call !character-database-cold-init)
+
   (show-and-call !early-package-cold-init)
   (show-and-call !package-cold-init)
   
@@ -313,7 +315,7 @@
 (defun hexstr (thing)
   (/noshow0 "entering HEXSTR")
   (let ((addr (get-lisp-obj-address thing))
-	(str (make-string 10)))
+	(str (make-string 10 :element-type 'base-char)))
     (/noshow0 "ADDR and STR calculated")
     (setf (char str 0) #\0
 	  (char str 1) #\x)
diff -urNb sbcl/src/code/cross-condition.lisp sbcl.char/src/code/cross-condition.lisp
--- sbcl/src/code/cross-condition.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/cross-condition.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -31,6 +31,9 @@
 (define-condition reference-condition ()
   ((references :initarg :references :reader reference-condition-references)))
 
+;;; KLUDGE
+(define-condition type-warning (simple-warning) ())
+
 (define-condition bug (simple-error)
   ()
   (:report
diff -urNb sbcl/src/code/cross-type.lisp sbcl.char/src/code/cross-type.lisp
--- sbcl/src/code/cross-type.lisp	2004-10-28 22:28:32.000000000 +0200
+++ sbcl.char/src/code/cross-type.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -82,6 +82,9 @@
 		  'fixnum)
 		 (t
 		  'integer)))
+          ((subtypep raw-result 'simple-string)
+           `(simple-base-string ,(length object)))
+          ((subtypep raw-result 'string) 'base-string)
 	  ((some (lambda (type) (subtypep raw-result type))
 		 '(array character list symbol))
 	   raw-result)
@@ -360,6 +363,11 @@
      (make-member-type :members (list x)))
     (number
      (ctype-of-number x))
+    (string
+     (make-array-type :dimensions (array-dimensions x)
+                      :complexp (not (typep x 'simple-array))
+                      :element-type (specifier-type 'base-char)
+                      :specialized-element-type (specifier-type 'base-char)))
     (array
      (let ((etype (specifier-type (array-element-type x))))
        (make-array-type :dimensions (array-dimensions x)
@@ -369,9 +377,7 @@
     (cons (specifier-type 'cons))
     (character
      (cond ((typep x 'standard-char)
-	    ;; (Note that SBCL doesn't distinguish between BASE-CHAR and
-	    ;; CHARACTER.)
-	    (specifier-type 'base-char))
+	    (specifier-type 'character))
 	   ((not (characterp x))
 	    nil)
 	   (t
diff -urNb sbcl/src/code/deftypes-for-target.lisp sbcl.char/src/code/deftypes-for-target.lisp
--- sbcl/src/code/deftypes-for-target.lisp	2004-10-28 22:28:33.000000000 +0200
+++ sbcl.char/src/code/deftypes-for-target.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -60,7 +60,8 @@
 
 (sb!xc:deftype atom () '(not cons))
 
-(sb!xc:deftype base-char () 'character)
+(sb!xc:deftype base-char ()
+  '(character-set ((0 . #.(1- base-char-code-limit)))))
 
 (sb!xc:deftype extended-char ()
   #!+sb-doc
diff -urNb sbcl/src/code/early-format.lisp sbcl.char/src/code/early-format.lisp
--- sbcl/src/code/early-format.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/early-format.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -18,9 +18,9 @@
 	  #-sb-xc-host (code-char tab-char-code)))
 
 (defvar *format-directive-expanders*
-  (make-array char-code-limit :initial-element nil))
+  (make-array base-char-code-limit :initial-element nil))
 (defvar *format-directive-interpreters*
-  (make-array char-code-limit :initial-element nil))
+  (make-array base-char-code-limit :initial-element nil))
 
 (defvar *default-format-error-control-string* nil)
 (defvar *default-format-error-offset* nil)
diff -urNb sbcl/src/code/fd-stream.lisp sbcl.char/src/code/fd-stream.lisp
--- sbcl/src/code/fd-stream.lisp	2004-10-29 14:57:35.000000000 +0200
+++ sbcl.char/src/code/fd-stream.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -357,6 +357,8 @@
 			   (fd-stream-obuf-tail stream))
 	byte))
 
+
+
 ;;; Do the actual output. If there is space to buffer the string,
 ;;; buffer it. If the string would normally fit in the buffer, but
 ;;; doesn't because of other stuff in the buffer, flush the old noise
@@ -1112,6 +1114,37 @@
   (setf (sap-ref-8 sap tail) bits)
   (code-char byte))
 
+(let ((latin-9-table (let ((table (make-string 256)))
+                       (do ((i 0 (1+ i)))
+                           ((= i 256))
+                         (setf (aref table i) (code-char i)))
+                       (setf (aref table #xa4) (code-char #x20ac))
+                       (setf (aref table #xa6) (code-char #x0160))
+                       (setf (aref table #xa8) (code-char #x0161))
+                       (setf (aref table #xb4) (code-char #x017d))
+                       (setf (aref table #xb8) (code-char #x017e))
+                       (setf (aref table #xbc) (code-char #x0152))
+                       (setf (aref table #xbd) (code-char #x0153))
+                       (setf (aref table #xbe) (code-char #x0178))
+                       table))
+      (latin-9-reverse-1 (make-array 16
+                                     :element-type '(unsigned-byte 21)
+                                     :initial-contents '(#x0160 #x0161 #x0152 #x0153 0 0 0 0 #x0178 0 0 0 #x20ac #x017d #x017e 0)))
+      (latin-9-reverse-2 (make-array 16
+                                     :element-type '(unsigned-byte 8)
+                                     :initial-contents '(#xa6 #xa8 #xbc #xbd 0 0 0 0 #xbe 0 0 0 #xa4 #xb4 #xb8 0))))
+  (define-external-format (:latin-9 :latin9 :iso-8859-15)
+      1
+    (setf (sap-ref-8 sap tail)
+          (if (< bits 256)
+              (if (= bits (char-code (aref latin-9-table bits)))
+                  bits
+                  (error "cannot encode ~A in latin-9" bits))
+              (if (= (aref latin-9-reverse-1 (logand bits 15)) bits)
+                  (aref latin-9-reverse-2 (logand bits 15))
+                  (error "cannot encode ~A in latin-9" bits))))
+    (aref latin-9-table byte)))
+
 (define-external-format/variable-width (:utf-8 :utf8)
   (let ((bits (char-code byte)))
     (cond ((< bits #x80) 1)
@@ -1811,7 +1844,8 @@
 	(make-fd-stream 1 :name "standard output" :output t :buffering :line))
   (setf *stderr*
 	(make-fd-stream 2 :name "standard error" :output t :buffering :line))
-  (let ((tty (sb!unix:unix-open "/dev/tty" sb!unix:o_rdwr #o666)))
+  (let* ((ttyname #.(coerce "/dev/tty" 'simple-base-string))
+	 (tty (sb!unix:unix-open ttyname sb!unix:o_rdwr #o666)))
     (if tty
 	(setf *tty*
 	      (make-fd-stream tty
diff -urNb sbcl/src/code/filesys.lisp sbcl.char/src/code/filesys.lisp
--- sbcl/src/code/filesys.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/filesys.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -192,8 +192,9 @@
       (values absolute (pieces)))))
 
 (defun parse-unix-namestring (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
            (type index start end))
+  (setf namestr (coerce namestr 'simple-base-string))
   (multiple-value-bind (absolute pieces) (split-at-slashes namestr start end)
     (multiple-value-bind (name type version)
 	(let* ((tail (car (last pieces)))
@@ -296,7 +297,7 @@
 	      (t
 	       (error "invalid pattern piece: ~S" piece))))))
        (apply #'concatenate
-	      'simple-string
+	      'simple-base-string
 	      (strings))))))
 
 (defun unparse-unix-directory-list (directory)
@@ -322,7 +323,7 @@
 	   (pieces "/"))
 	  (t
 	   (error "invalid directory component: ~S" dir)))))
-    (apply #'concatenate 'simple-string (pieces))))
+    (apply #'concatenate 'simple-base-string (pieces))))
 
 (defun unparse-unix-directory (pathname)
   (declare (type pathname pathname))
@@ -350,18 +351,18 @@
       (when type-supplied
 	(unless name
 	  (error "cannot specify the type without a file: ~S" pathname))
-	(when (typep type 'simple-base-string)
+	(when (typep type 'simple-string)
 	  (when (position #\. type)
 	    (error "type component can't have a #\. inside: ~S" pathname)))
 	(strings ".")
 	(strings (unparse-unix-piece type))))
-    (apply #'concatenate 'simple-string (strings))))
+    (apply #'concatenate 'simple-base-string (strings))))
 
 (/show0 "filesys.lisp 406")
 
 (defun unparse-unix-namestring (pathname)
   (declare (type pathname pathname))
-  (concatenate 'simple-string
+  (concatenate 'simple-base-string
 	       (unparse-unix-directory pathname)
 	       (unparse-unix-file pathname)))
 
@@ -445,6 +446,7 @@
 				   (follow-links t))
 			      &body body)
   `(block nil
+     (/show0 "about to call %ENUMERATE-MATCHES")
      (%enumerate-matches (pathname ,pathname)
 			 ,verify-existence
 			 ,follow-links
@@ -455,7 +457,7 @@
 
 ;;; Call FUNCTION on matches.
 (defun %enumerate-matches (pathname verify-existence follow-links function)
-  (/noshow0 "entering %ENUMERATE-MATCHES")
+  (/show0 "entering %ENUMERATE-MATCHES")
   (when (pathname-type pathname)
     (unless (pathname-name pathname)
       (error "cannot supply a type without a name:~%  ~S" pathname)))
@@ -463,16 +465,16 @@
 	     (member (pathname-type pathname) '(nil :unspecific)))
     (error "cannot supply a version without a type:~%  ~S" pathname))
   (let ((directory (pathname-directory pathname)))
-    (/noshow0 "computed DIRECTORY")
+    (/show0 "computed DIRECTORY")
     (if directory
 	(ecase (first directory)
 	  (:absolute
-	   (/noshow0 "absolute directory")
+	   (/show0 "absolute directory")
 	   (%enumerate-directories "/" (rest directory) pathname
 				   verify-existence follow-links
 				   nil function))
 	  (:relative
-	   (/noshow0 "relative directory")
+	   (/show0 "relative directory")
 	   (%enumerate-directories "" (rest directory) pathname
 				   verify-existence follow-links
 				   nil function)))
@@ -576,16 +578,17 @@
 ;;; Call FUNCTION on files.
 (defun %enumerate-files (directory pathname verify-existence function)
   (declare (simple-string directory))
-  (/noshow0 "entering %ENUMERATE-FILES")
+  (/show0 "entering %ENUMERATE-FILES")
   (let ((name (%pathname-name pathname))
 	(type (%pathname-type pathname))
 	(version (%pathname-version pathname)))
-    (/noshow0 "computed NAME, TYPE, and VERSION")
+    (/show0 "computed NAME, TYPE, and VERSION")
     (cond ((member name '(nil :unspecific))
 	   (/noshow0 "UNSPECIFIC, more or less")
+	   (let ((directory (coerce directory 'base-string)))
 	   (when (or (not verify-existence)
 		     (sb!unix:unix-file-kind directory))
-	     (funcall function directory)))
+	       (funcall function directory))))
 	  ((or (pattern-p name)
 	       (pattern-p type)
 	       (eq name :wild)
@@ -613,20 +616,20 @@
 				       directory
 				       complete-filename))))))
 	  (t
-	   (/noshow0 "default case")
+	   (/show0 "default case")
 	   (let ((file (concatenate 'base-string directory name)))
-	     (/noshow "computed basic FILE")
+	     (/show0 "computed basic FILE")
 	     (unless (or (null type) (eq type :unspecific))
-	       (/noshow0 "tweaking FILE for more-or-less-:UNSPECIFIC case")
+	       (/show0 "tweaking FILE for more-or-less-:UNSPECIFIC case")
 	       (setf file (concatenate 'base-string file "." type)))
 	     (unless (member version '(nil :newest :wild :unspecific))
-	       (/noshow0 "tweaking FILE for more-or-less-:WILD case")
+	       (/show0 "tweaking FILE for more-or-less-:WILD case")
 	       (setf file (concatenate 'base-string file "."
 				       (quick-integer-to-string version))))
-	     (/noshow0 "finished possibly tweaking FILE")
+	     (/show0 "finished possibly tweaking FILE")
 	     (when (or (not verify-existence)
 		       (sb!unix:unix-file-kind file t))
-	       (/noshow0 "calling FUNCTION on FILE")
+	       (/show0 "calling FUNCTION on FILE")
 	       (funcall function file)))))))
 
 (/noshow0 "filesys.lisp 603")
@@ -679,6 +682,7 @@
 ;;; Convert PATHNAME into a string that can be used with UNIX system
 ;;; calls, or return NIL if no match is found. Wild-cards are expanded.
 (defun unix-namestring (pathname-spec &optional (for-input t))
+  (/show0 "in UNIX-NAMESTRING")
   (let* ((namestring (physicalize-pathname (merge-pathnames pathname-spec)))
 	 (matches nil)) ; an accumulator for actual matches
     (when (wild-pathname-p namestring)
@@ -716,12 +720,16 @@
   #!+sb-doc
   "Return a pathname which is the truename of the file if it exists, or NIL
   otherwise. An error of type FILE-ERROR is signaled if pathname is wild."
+  (/show0 "in PROBE-FILE")
   (let* ((defaulted-pathname (merge-pathnames
 			      pathname
 			      (sane-default-pathname-defaults)))
 	 (namestring (unix-namestring defaulted-pathname t)))
+    (/show0 "got NAMESTRING")
     (when (and namestring (sb!unix:unix-file-kind namestring t))
+      (/show0 "got FILE-KIND")
       (let ((trueishname (sb!unix:unix-resolve-links namestring)))
+	(/show0 "resolved links")
 	(when trueishname
 	  (let* ((*ignore-wildcards* t)
 		 (name (sb!unix:unix-simplify-pathname trueishname))) 
@@ -1040,7 +1048,7 @@
 			       :device (pathname-device pathname)
 			       :directory (subseq dir 0 i))))
 		 (unless (probe-file newpath)
-		   (let ((namestring (namestring newpath)))
+		   (let ((namestring (coerce (namestring newpath) 'base-string)))
 		     (when verbose
 		       (format *standard-output*
 			       "~&creating directory: ~A~%"
diff -urNb sbcl/src/code/fop.lisp sbcl.char/src/code/fop.lisp
--- sbcl/src/code/fop.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/fop.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -71,11 +71,12 @@
 ;;; of like READ-SEQUENCE specialized for files of (UNSIGNED-BYTE 8),
 ;;; with an automatic conversion from (UNSIGNED-BYTE 8) into CHARACTER
 ;;; for each element read
-(declaim (ftype (function (stream simple-string &optional index) (values)) read-string-as-bytes))
+(declaim (ftype (function (stream simple-string &optional index) (values))
+                read-string-as-bytes read-string-as-words))
 (defun read-string-as-bytes (stream string &optional (length (length string)))
   (dotimes (i length)
     (setf (aref string i)
-	  (code-char (read-byte stream))))
+	  (sb!xc:code-char (read-byte stream))))
   ;; FIXME: The classic CMU CL code to do this was
   ;;   (READ-N-BYTES FILE STRING START END).
   ;; It was changed for SBCL because we needed a portable version for
@@ -83,6 +84,16 @@
   ;; significantly better than the portable version here. If it is, then use
   ;; it as an alternate definition, protected with #-SB-XC-HOST.
   (values))
+(defun read-string-as-words (stream string &optional (length (length string)))
+  #+sb-xc-host (bug "READ-STRING-AS-WORDS called")
+  (dotimes (i length)
+    (setf (aref string i)
+	  (sb!xc:code-char (logior
+                            (read-byte stream)
+                            (ash (read-byte stream) 8)
+                            (ash (read-byte stream) 16)
+                            (ash (read-byte stream) 24)))))
+  (values))
 
 ;;;; miscellaneous fops
 
@@ -123,11 +134,8 @@
   #-sb-xc-host
   (%primitive sb!c:make-other-immediate-type 0 sb!vm:unbound-marker-widetag))
 
-;;; CMU CL had FOP-CHARACTER as fop 68, but it's not needed in current
-;;; SBCL as we have no extended characters, only 1-byte characters.
-;;; (Ditto for CMU CL, actually: FOP-CHARACTER was speculative generality.)
-(define-fop (fop-short-character 69)
-  (code-char (read-byte-arg)))
+(define-cloned-fops (fop-character 68) (fop-short-character 69)
+  (code-char (clone-arg)))
 
 (define-cloned-fops (fop-struct 48) (fop-small-struct 49)
   (let* ((size (clone-arg))
@@ -183,9 +191,14 @@
 			      (make-string (* ,n-size 2))))
 		      (done-with-fast-read-byte)
 		      (let ((,n-buffer *fasl-symbol-buffer*))
+                        #+sb-xc-host
 			(read-string-as-bytes *fasl-input-stream*
 					      ,n-buffer
 					      ,n-size)
+                        #-sb-xc-host
+			(read-string-as-words *fasl-input-stream*
+					      ,n-buffer
+					      ,n-size)
 			(push-fop-table (without-package-locks
 					 (intern* ,n-buffer
 						  ,n-size
@@ -232,7 +245,7 @@
 		    (fop-uninterned-small-symbol-save 13)
   (let* ((arg (clone-arg))
 	 (res (make-string arg)))
-    (read-string-as-bytes *fasl-input-stream* res)
+    (read-string-as-words *fasl-input-stream* res)
     (push-fop-table (make-symbol res))))
 
 (define-fop (fop-package 14)
@@ -344,12 +357,23 @@
 
 ;;;; fops for loading arrays
 
-(define-cloned-fops (fop-string 37) (fop-small-string 38)
+(define-cloned-fops (fop-base-string 37) (fop-small-base-string 38)
   (let* ((arg (clone-arg))
-	 (res (make-string arg)))
+	 (res (make-string arg :element-type 'base-char)))
     (read-string-as-bytes *fasl-input-stream* res)
     res))
 
+#+sb-xc-host
+(define-cloned-fops (fop-character-string 161) (fop-small-character-string 162)
+  (bug "CHARACTER-STRING FOP encountered"))
+
+#-sb-xc-host
+(define-cloned-fops (fop-character-string 161) (fop-small-character-string 162)
+  (let* ((arg (clone-arg))
+	 (res (make-string arg)))
+    (read-string-as-words *fasl-input-stream* res)
+    res))
+
 (define-cloned-fops (fop-vector 39) (fop-small-vector 40)
   (let* ((size (clone-arg))
 	 (res (make-array size)))
@@ -639,7 +663,7 @@
   (let* ((kind (pop-stack))
 	 (code-object (pop-stack))
 	 (len (read-byte-arg))
-	 (sym (make-string len)))
+	 (sym (make-string len :element-type 'base-char)))
     (read-n-bytes *fasl-input-stream* sym 0 len)
     (sb!vm:fixup-code-object code-object
 			     (read-word-arg)
diff -urNb sbcl/src/code/host-c-call.lisp sbcl.char/src/code/host-c-call.lisp
--- sbcl/src/code/host-c-call.lisp	2004-10-29 14:57:35.000000000 +0200
+++ sbcl.char/src/code/host-c-call.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -14,9 +14,8 @@
 (define-alien-type-class (c-string :include pointer :include-args (to)))
 
 (define-alien-type-translator c-string ()
-  (make-alien-c-string-type :to
-			    (parse-alien-type 'char
-					      (sb!kernel::make-null-lexenv))))
+  (make-alien-c-string-type
+   :to (parse-alien-type 'char (sb!kernel:make-null-lexenv))))
 
 (define-alien-type-method (c-string :unparse) (type)
   (declare (ignore type))
@@ -24,7 +23,7 @@
 
 (define-alien-type-method (c-string :lisp-rep) (type)
   (declare (ignore type))
-  '(or simple-base-string null (alien (* char))))
+  '(or simple-string null (alien (* char))))
 
 (define-alien-type-method (c-string :naturalize-gen) (type alien)
   (declare (ignore type))
@@ -37,7 +36,8 @@
   `(etypecase ,value
      (null (int-sap 0))
      ((alien (* char)) (alien-sap ,value))
-     (simple-base-string (vector-sap ,value))))
+     (simple-base-string (vector-sap ,value))
+     (simple-string (vector-sap (coerce ,value 'simple-base-string)))))
 
 (/show0 "host-c-call.lisp 42")
 
diff -urNb sbcl/src/code/interr.lisp sbcl.char/src/code/interr.lisp
--- sbcl/src/code/interr.lisp	2004-10-28 22:28:34.000000000 +0200
+++ sbcl.char/src/code/interr.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -123,6 +123,16 @@
 	 :datum object
 	 :expected-type 'base-string))
 
+(deferr object-not-vector-nil-error (object)
+  (error 'type-error
+	 :datum object
+	 :expected-type '(vector nil)))
+
+(deferr object-not-character-string-error (object)
+  (error 'type-error
+	 :datum object
+	 :expected-type '(vector character)))
+
 (deferr object-not-bit-vector-error (object)
   (error 'type-error
 	 :datum object
diff -urNb sbcl/src/code/late-format.lisp sbcl.char/src/code/late-format.lisp
--- sbcl/src/code/late-format.lisp	2004-10-28 22:28:35.000000000 +0200
+++ sbcl.char/src/code/late-format.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -39,7 +39,7 @@
   (string (missing-arg) :type simple-string)
   (start (missing-arg) :type (and unsigned-byte fixnum))
   (end (missing-arg) :type (and unsigned-byte fixnum))
-  (character (missing-arg) :type base-char)
+  (character (missing-arg) :type character)
   (colonp nil :type (member t nil))
   (atsignp nil :type (member t nil))
   (params nil :type list))
@@ -270,8 +270,11 @@
   (etypecase directive
     (format-directive
      (let ((expander
-	    (aref *format-directive-expanders*
-		  (char-code (format-directive-character directive))))
+            (let ((char (format-directive-character directive)))
+              (typecase char
+                (base-char
+                 (aref *format-directive-expanders* (char-code char)))
+                (character nil))))
 	   (*default-format-error-offset*
 	    (1- (format-directive-end directive))))
        (declare (type (or null function) expander))
